'#### Outlook Samurize Script offline cache update tool
'#### Version 1.0
'#### Copyright 2004 - John Newman
'#### Do not distribute without express permission from author
'#### Created by John Newman aka rubjonny, please post feedback to rubjonny@moddin.net

On Error Resume Next

strCalFile  = "CalFile.txt"	'#### Set Path to offline Calendar cache (relative to Samurize scripts folder)
strTaskFile = "TaskFile.txt"	'#### Set Path to offline Tasks cache (relative to Samurize scripts folder)
strMailFile = "MailFile.txt"	'#### Set Path to offline Mail cache (relative to Samurize scripts folder)
strMaxDays  = "30"		'#### Set max number of days in the future to retrieve, helps you have lots of recurring items
strMinDays  = "30"		'#### Set max number of days in the past to retrieve, helps you have lots of recurring items
strFixOutlook = "0"		'#### Enable Outlook popup work around

Set wshFSO  = CreateObject("Scripting.FileSystemObject")
strCalFile = wshFSO.GetAbsolutePathName("") & "\" & strCalFile
strTaskFile = wshFSO.GetAbsolutePathName("") & "\" & strTaskFile
strMailFile = wshFSO.GetAbsolutePathName("") & "\" & strMailFile

Set objApp = GetObject(, "Outlook.Application")	'#### Find existing instance of Outlook
If Err Then
  Set objApp = CreateObject("Outlook.Application")	'#### uncomment this & comment out above line to get data even if Outlook isnt running
End If
  Set objOutlook = objApp.GetNameSpace("MAPI")		'#### Get MAPI namespace

  Set objCalItems  = objOutlook.GetDefaultFolder(9).Items	'#### Get Calendar folder items
  Set objTaskItems = objOutlook.GetDefaultFolder(13).Items	'#### Get Task folder items
  Set objMailItems = objOutlook.GetDefaultFolder(6).Items	'#### Get Inbox folder items

  objTaskItems.IncludeRecurrences = True		'#### Include  reoccurring task items
  objCalItems.IncludeRecurrences = True			'#### Include  reoccurring calendar items

  dtRestMin = cdate(Date-strMinDays-1)			'#### Set min & max restriction dates
  dtRestMax = cdate(Date+strMaxDays)
  objCalItems.Sort "[Start]", False
  objMailItems.Sort "[ReceivedTime]", True

  strRestrict = "[Start] >= '" & dtRestMin & "' and [Start] <= '" & dtRestMax & "'"
  Set objCalItems = objCalItems.Restrict(strRestrict)	'#### Restrict returned items (helps when you have lots of recurring items)
  'strMailRest = "[ReceivedTime] >= '" & dtRestMin & "' and [ReceivedTime] <= '" & dtRestMax & "'"
  Set objCalItems = objCalItems.Restrict(strRestrict)	'#### Restrict returned items (helps when you have lots of recurring items)

  objCalItems.Sort "[Start]", False
  objTaskItems.Sort "[DueDate]", False			'#### Sort items
  objMailItems.Sort "[ReceivedTime]", True

  Set objTextStream1 = wshFSO.CreateTextFile(strCalFile, True)
  Set objTextStream2 = wshFSO.CreateTextFile(strTaskFile, True)
  Set objTextStream3 = wshFSO.CreateTextFile(strMailFile, True)
  For each item in objCalItems
    If item.IsRecurring = True then
       strCalRecuring = "True"
    Else
       strCalRecuring = "False"
    End If
    objTextStream1.Writeline item.Start & "%1%" & item.End & "%2%" & item & "%3%" & item.Location & "%4%" & strCalRecuring & "%5%"
  Next
  For each item in objTaskItems
    If Item.Complete = True then 
      strTaskCompleted = "True"
    Else
       strTaskCompleted = "False"
    End If
    If item.IsRecurring = True then
       strTaskRecuring = "True"
    Else
       strTaskRecuring = "False"
    End If
    objTextStream2.Writeline Item.DueDate & "%1%" & item.DateCompleted & "%2%" & Item.Subject & "%3%" & strTaskCompleted & "%4%" & strTaskRecuring & "%5%" & Item.Importance & "%6%"
  Next
  strMUnread = "0"
  strMTotal  = "0"
  For each item in objMailItems
    If Item.ReceivedTime <> "" Then
      If strFixOutlook <> "1" Then
        strItemSenderName = Item.SenderName
      Else
        strItemSenderName = "[null]"
      End If
      objTextStream3.Writeline Item.UnRead & "%1%" & Item.ReceivedTime & "%2%" & Item.Subject & "%3%" & strItemSenderName & "%4%" & Item.Importance & "%5%"
      If Item.Unread = "True" Then strMUnread = strMUnread+1
      strMTotal = strMTotal+1
    End If
  Next
  objtextstream3.Writeline strMTotal & "%Total%" & strMUnread & "%Unread%"
  objTextStream1.close
  objTextStream2.close
  objTextStream3.close
